/*
OBIETTIVI: USARE LA RICORSIONE, USARE LA CLASSE String

Una stringa  palindroma se letta nei due versi risulta uguale.
Esempi di stringhe palindrome:
ANNa
RaDAr
OTto
MADAmIMaDAM
EVe

Se si ignorano i caratteri diversi dalle lettere, sono palindrome:
Madam, I'm Adam.         
Able was I 'ere I saw Elba.    
A man. A plan. A canal. Panama!

Scrivere un metodo che usa la ricorsione per verificare se una stringa  palindroma


RIPASSO:
Il metodo substring(int beginIndex [, int endIndex]) restituisce una nuova
stringa che e' una sottostringa della stringa corrente.
La sottostringa inizia con il carattere in posizione beginIndex e si estende
fino alla fine della stringa oppure fino alla posizione endIndex-1 se
il secondo parametro e' specificato.
*/



public class Palindrome { 


/*****************************************************
* metodo valido per stringhe composte da sole lettere
tutte maiuscole/minuscole  ("ANNA")
******************************************************/
public static boolean isPalindrome (String s) {
         if (s.length() <= 1)
             return true;
         if (s.charAt (0) != s.charAt (s.length() - 1))
             return false;
         return isPalindrome (s.substring (1, s.length() - 1));   //NB 
    } // method isPalindrome


/*********************************************************************************
* Estensione del metodo valida senza distinzione tra lettere maiuscole e minuscole,
* ignorando caratteri diversi dalle lettere.
* Ad esempio, sono palindrome:
* Madam, I'm Adam.         
* Able was I 'ere I saw Elba.    
*A man. A plan. A canal. Panama!
**********************************************************************************/

    public static boolean isPalindrome2 (String s) 
    {                     
       String letters = new String();

       for (int i = 0; i < s.length(); i++){
   	  char c=s.charAt(i);
	  if (  (c >='a' && c <='z') || (c >='A' && c <='Z'))
		letters += c;
	}	
       if (letters.length() == 0) return true;
       letters = letters.toUpperCase();        
       return isPalindrome (letters);
    } // method isPalindrome2


/**********************************************/
    public static boolean islowerletter(char c){
	return (c >='a' && c <='z');
    }

    public static boolean isupperletter(char c){
	return (c >='A' && c <='Z');
    }

    public static boolean isletter(char c){
	return islowerletter(c) || isupperletter(c);
    }

    public static char toupperletter(char c){
	if (islowerletter(c)) return (char)('A'+(c-'a'));
	else return c;
    }



public static boolean isPalindrome3 (String s) {
   if (s.length() <= 1) return true;

   int i = 0, j = s.length() - 1;
   while (i<j) {
     char c1 = s.charAt(i);
     while (!isletter(c1) && i<j) i++; //ignora caratteri non lettera
     char c2 = s.charAt(j);
     while (!isletter(c2) && i<j) j--; //ignora caratteri non lettera
     if (i==j) return true;
     else if (toupperletter(c1) != toupperletter(c2)) return false;
     i++; j--;
   } 
   return true;
} // method isPalindrome3




   public static void main(String args[]) {
	String s="An!n  a";
	if (isPalindrome3(s)) 
	   System.out.println(s + " e' palindroma");
	else
	   System.out.println(s + " non e' palindroma");
   }


}
